/*
 * ManipulatorFactory.cpp
 */

#include <subsys/factories/ManipulatorFactory.h>
#include <subsys/ProtoSubsys.h>


ProtoSubsys* ManipulatorFactory::m_proto = nullptr;//Init the instance to nullptr

//----------------------------------------------------------------------------------
// Method:      GetPrototype
// Description: If there isn't an instance of desired ProtoType class, create it.
//              Otherwise, hand out the single instance.
// Returns:     ProtoSubsys*    Chassis factory
//----------------------------------------------------------------------------------
ProtoSubsys* ManipulatorFactory::GetPrototype()
{
	if (ManipulatorFactory::m_proto == nullptr)
	{
		ManipulatorFactory::m_proto = new ProtoSubsys();
	}
	return ManipulatorFactory::m_proto;
}
