/*
 * ChassisDefn.h
 */

#ifndef SRC_SUBSYS_XMLPARSING_CHASSISDEFN_H_
#define SRC_SUBSYS_XMLPARSING_CHASSISDEFN_H_

#include <subsys/interfaces/IChassis.h>
#include <thirdParty/puxixml/pugixml.hpp>

class ChassisDefn
{
	public:
		ChassisDefn() = delete;
		virtual ~ChassisDefn() = delete;

		//-----------------------------------------------------------------------
		// Method:      ParseXML
		// Description: Parse a Chassis XML element and create an IChassis from
		//              its definition.
		// Returns:     IChassis*        	chassis (or nullptr if XML
		//                                  is ill-formed)
		//-----------------------------------------------------------------------
		static IChassis* ParseXML
		(
			pugi::xml_node      chassisNode
		);
};

#endif /* SRC_SUBSYS_XMLPARSING_CHASSISDEFN_H_ */
