/*
 * ChassisDefn.h
 *
 *  Created on: Aug 18, 2017
 *      Author: witcpale
 */

#ifndef SRC_DEFINITIONS_CHASSISDEFN_H_
#define SRC_DEFINITIONS_CHASSISDEFN_H_

namespace Team302
{

	class ChassisDefn
	{
		public:
			enum chassisType
			{
				UNKNOWN_CHASSIS,
				TANK_CHASSIS,
				MECANUM_CHASSIS,
				MAX_CHASSIS_TYPES
			};

			ChassisDefn() = delete;
			ChassisDefn
			(
				chassisType type,
				float		wheelBase,
				float		track
			);
			virtual ~ChassisDefn() = default;

			inline chassisType GetChassisType() { return m_type; }
			inline float GetWheelBase() { return m_wheelBase; }
			inline float GetTrack() { return m_track; }

		private:
			chassisType 	m_type;
			float			m_wheelBase;
			float			m_track;
	};

} /* namespace Team302 */

#endif /* SRC_DEFINITIONS_CHASSISDEFN_H_ */
