/*
 * EncoderDefn.cpp
 *
 *  Created on: Aug 18, 2017
 *      Author: witcpale
 */

#include <definitions/EncoderDefn.h>

namespace Team302
{

	EncoderDefn::EncoderDefn
	(
		int					channelA,				// <I> - first the counting channels or -1 if plugged directly into motor controller
		int					channelB,				// <I> - second the counting channels or -1 if plugged directly into motor controller
		bool 				isReverse,				// <I> - true, it will reverse the sensor reading
		EncoderSampleRate 	sampleRate,				// <I> - sampling rate from the specifications
		int		 			numChannels,    		// <I> - number of channels
		int		 			pulsesPerRev,			// <I> - pulses per revolution per the specifications
		float 				encodeRevsPerOutputRev,	// <I> - This is the gear ratio if the encoder is on the motor not the output shaft
		float	 			outputDiameter,			// <I> - Often wheel diameter.  This is used to calculate distance, speed, etc.
		DistanceUnit	 	unit					// <I> - units of the OutputDiameter
	) : m_channelA ( channelA ),
		m_channelB( channelB ),
		m_reversed( isReverse ),
		m_sampleRate( sampleRate ),
		m_numChannels( numChannels ),
		m_pulsesPerRev( pulsesPerRev ),
		m_outputRatio( encodeRevsPerOutputRev ),
		m_outputDiameter( outputDiameter ),
		m_unit( unit )
	{
	}

} /* namespace Team302 */
