/*
 * GyroDefn.h
 *
 *  Created on: Aug 18, 2017
 *      Author: witcpale
 */

#ifndef SRC_DEFINITIONS_GYRODEFN_H_
#define SRC_DEFINITIONS_GYRODEFN_H_

#include <definitions/AnalogInputDefn.h>

namespace Team302
{

	class GyroDefn : public AnalogInputDefn
	{
		public:
			GyroDefn() = delete;
			GyroDefn
			(
				int				channel, 		// <I> - analog channel
				float 			voltsPerDegree,	// <I> - Indicates how to convert from raw voltage to degrees of rotation
				float 			deadband,		// <I> - Indicates the range from center to ignore (volts)
				float 			center,			// <I> - Indicates the preset uncalibrated value to use as the accumulator center
				float 			offset,			// <I> - Indicates the preset uncalibrated value to use as the gyro offset
				float 			sensitivity		// <I> - Indicates the sensitivity (volts/degree/second) from the data sheet
			);
			virtual ~GyroDefn() = default;

			inline float GetVoltsPerDegree() { return GetVoltageConversionFactor(); }
			inline float GetDeadBand() { return m_deadband; }
			inline float GetCenter() { return m_center; }
			inline float GetOffset() { return m_offset; }
			inline float GetSensitivity() { return m_sensitivity; }

		private:
			float			m_deadband;
			float			m_center;
			float			m_offset;
			float			m_sensitivity;
	};

} /* namespace Team302 */

#endif /* SRC_DEFINITIONS_GYRODEFN_H_ */
