/*
 * PotentiometerDefn.h
 *
 *  Created on: Aug 18, 2017
 *      Author: witcpale
 */

#ifndef SRC_DEFINITIONS_POTENTIOMETERDEFN_H_
#define SRC_DEFINITIONS_POTENTIOMETERDEFN_H_

namespace Team302
{

	class PotentiometerDefn
	{
		public:
			PotentiometerDefn() = delete;
			PotentiometerDefn
			(
				int				channel, 		// <I> - input this is plugged into
				float			range, 			// <I> - The scaling factor to convert from voltage to a meaningful value
				float 			offset			// <I> - The value to add to the scaled value for controlling 0
			);
			virtual ~PotentiometerDefn() = default;

			inline int GetChannel() { return m_channel; }
			inline float GetRange() { return m_range; }
			inline float GetOffset() { return m_offset; }

		private:
			int				m_channel;
			float			m_range;
			float 			m_offset;
	};

} /* namespace Team302 */

#endif /* SRC_DEFINITIONS_POTENTIOMETERDEFN_H_ */
