/*
 * UltrasonicRangeFinderDefn.h
 *
 *  Created on: Aug 18, 2017
 *      Author: witcpale
 */

#ifndef SRC_DEFINITIONS_ULTRASONICRANGEFINDERDEFN_H_
#define SRC_DEFINITIONS_ULTRASONICRANGEFINDERDEFN_H_

namespace Team302
{

	class UltrasonicRangeFinderDefn
	{
		public:
			enum DistanceUnit
			{
				INCHES,
				MM
			};
			UltrasonicRangeFinderDefn() = delete;
			UltrasonicRangeFinderDefn
			(
				int				pingChannel,		// <I> - digital input or pinging channel
				int				echoChannel,		// <I> - digital output or echo channel
				bool 			isAutomatic,		// <I> - true will causes ultrasonic range finders to fire in sequece to avoid interference
				DistanceUnit	units				// <I> - units for distance
			);
			virtual ~UltrasonicRangeFinderDefn() = default;

			inline int GetPingChannel() { return m_pingChannel; }
			inline int GetEchoChannel() { return m_echoChannel; }
			inline bool IsAutomatic() { return m_automatic; }
			inline DistanceUnit GetUnitType() { return m_unit; }

		private:
			int 			m_pingChannel;
			int				m_echoChannel;
			bool			m_automatic;
			DistanceUnit	m_unit;
	};

} /* namespace Team302 */

#endif /* SRC_DEFINITIONS_ULTRASONICRANGEFINDERDEFN_H_ */
