/*
 * RobotParser.h
 *
 *  Created on: Aug 18, 2017
 *      Author: witcpale
 */

#ifndef SRC_SUBSYS_ROBOTPARSER_H_
#define SRC_SUBSYS_ROBOTPARSER_H_


#include <thirdparty/pugixml/pugixml.hpp>

#include <vector>


namespace Team302
{
class ChassisDefn;
class ManipulatorDefn;
class PCMDefn;

	class RobotParser
	{
		public:
			RobotParser();
			virtual ~RobotParser();

		private:
			void ParseChassis
			(
				pugi::xml_node thisElement			// <I> - The Chassis XML element
			);

			void ParseManipulator
			(
				pugi::xml_node thisElement			// <I> - The Manipulator XML element
			);

			void ParsePCM
			(
				pugi::xml_node thisElement			// <I> - The PCM XML element
			);

			void ParseSolenoid
			(
				pugi::xml_node thisElement			// <I> - The Solenoid XML element
			);

			ChassisDefn*					m_chassis;
			std::vector<ManipulatorDefn*>	m_manipulators;
			PCMDefn*						m_pcm;
	};

} /* namespace Team302 */

#endif /* SRC_SUBSYS_ROBOTPARSER_H_ */
