/*
 * ArcadeDrive.h
 *
 *  Created on: Jan 14, 2017
 *      Author: Tumtu
 */

#ifndef SRC_ARCADEDRIVE_H_
#define SRC_ARCADEDRIVE_H_

#include <teleopDrive/TeleDriveBase.h>

namespace Team302
{

	class ArcadeDrive : public TeleDriveBase
	{
		public:

			//--------------------------------------------------------------------------------
			// Method:			ArcadeDrive
			// Description: 	Default Constructor
			// Returns: 		void
			//--------------------------------------------------------------------------------
			ArcadeDrive();      // constructor

			//--------------------------------------------------------------------------------
			// Method:			~ArcadeDrive
			// Description: 	Default Destructor
			// Returns: 		void
			//--------------------------------------------------------------------------------
			virtual ~ArcadeDrive() = default; // destructor

			//--------------------------------------------------------------------------------
			// Method:			DriveWithJoysticks
			// Description: 	Reads the DragonXBox stick values and sends the appropriate
			//					values to the drive wheels
			// Returns: 		void
			//--------------------------------------------------------------------------------
			void DriveWithJoysticks() const override;

		protected:

		private:
			const float NUDGE_AMOUNT = 10;

			// Default methods we don't want the compiler to implement
			ArcadeDrive( const ArcadeDrive& ) = delete;
			ArcadeDrive& operator= ( const ArcadeDrive& ) = delete;
			explicit ArcadeDrive( ArcadeDrive* other ) = delete;

	};

}

/* namespace Team302 */

#endif /* SRC_ARCADEDRIVE_H_ */
