/*
 * TeleDriveBase.cpp
 *
 *  Created on: May 8, 2017
 *      Author: witcpale
 */

#include <driverInputs/DragonXbox.h>
#include <subsys/ChassisFactory.h>
#include <teleopDrive/TeleDriveBase.h>

namespace Team302
{

	//--------------------------------------------------------------------------------
	// Method:			TeleDriveBase
	// Description: 	Default Constructor
	// Returns: 		void
	//--------------------------------------------------------------------------------
	TeleDriveBase::TeleDriveBase() : IDrive()
	{
		m_chassis = ChassisFactory::GetInstance()->GetIChassis();
	}

	//--------------------------------------------------------------------------------
	// Method:			UpdateCurrentLimiting
	// Description: 	Checks if the current limiting inputs are selected and
	//					updates the settings if selected.
	// Returns: 		void
	//--------------------------------------------------------------------------------
	void TeleDriveBase::UpdateCurrentLimiting() const
	{
		// Check current limiting buttons, Y: enable, A: disable
		if (DragonXbox::GetDriver()->GetButton(DragonXbox::Y_BUTTON))
		{
			m_chassis->EnableCurrentLimiting( true );
		}
		else if (DragonXbox::GetDriver()->GetButton(DragonXbox::A_BUTTON))
		{
			m_chassis->EnableCurrentLimiting( false );
		}
	}

} /* namespace Team302 */
