/*
 * TeleDriveBase.h
 *
 */

#ifndef SRC_TeleDriveBase_TELEDRIVEBASE_H_
#define SRC_TeleDriveBase_TELEDRIVEBASE_H_

#include <subsys/IChassis.h>
#include <teleopDrive/IDrive.h>

namespace Team302
{

	class TeleDriveBase: public IDrive
	{
		public:

			//--------------------------------------------------------------------------------
			// Method:			TeleDriveBase
			// Description: 	Default Constructor
			// Returns: 		void
			//--------------------------------------------------------------------------------
			TeleDriveBase();      // constructor

			//--------------------------------------------------------------------------------
			// Method:			~TeleDriveBase
			// Description: 	Default Destructor
			// Returns: 		void
			//--------------------------------------------------------------------------------
			virtual ~TeleDriveBase() = default; // destructor

		protected:
			//--------------------------------------------------------------------------------
			// Method:			UpdateCurrentLimiting
			// Description: 	Checks if the current limiting inputs are selected and
			//					updates the settings if selected.
			// Returns: 		void
			//--------------------------------------------------------------------------------
			void UpdateCurrentLimiting() const;

			// Attributes
			IChassis*               m_chassis;

		private:
			// Default methods we don't want the compiler to implement
			TeleDriveBase( const TeleDriveBase& ) = delete;
			TeleDriveBase& operator= ( const TeleDriveBase& ) = delete;
			explicit TeleDriveBase( TeleDriveBase* other ) = delete;

	};

}

/* namespace Team302 */

#endif /* SRC_TeleDriveBase_TELEDRIVEBASE_H_ */
