/*
 * ITest.h
 *
 */

#ifndef SRC_TEST_ITEST_H_
#define SRC_TEST_ITEST_H_


class ITest
{

    public:

        enum ITEST_CASE_ID
        {
        	PROTOTYPE_TEST,
        	DRAGONXBOX_START,
            DRAGONXBOX_LINEAR_FULL_SCALE,      // Both Joysticks have a range of -1.0 to 1.0 and a linear scale
			DRAGONXBOX_LINEAR_HALF_SCALE,      // Both Joysticks have a range of -0.5 to 0.5 and a linear scale
			DRAGONXBOX_CUBIC_FULL_SCALE,       // Both Joysticks have a range of -1.0 to 1.0 and a cubic scale
			DRAGONXBOX_CUBIC_HALF_SCALE,       // Both Joysticks have a range of -0.5 to 0.5 and a cubic scale
			DRAGONXBOX_END,
			TELEOPCONTROL_START,
			TELEOPCONTROL_TANK_DRIVE_LEFT_LINEAR,
			TELEOPCONTROL_TANK_DRIVE_RIGHT_LINEAR,
			TELEOPCONTROL_TANK_DRIVE_LEFT_CUBIC,
			TELEOPCONTROL_TANK_DRIVE_RIGHT_CUBIC,
			TELEOPCONTROL_SCALED_TANK_DRIVE_LEFT_LINEAR,
			TELEOPCONTROL_SCALED_TANK_DRIVE_RIGHT_LINEAR,
			TELEOPCONTROL_SCALED_TANK_DRIVE_LEFT_CUBIC,
			TELEOPCONTROL_SCALED_TANK_DRIVE_RIGHT_CUBIC,
			TELEOPCONTROL_ARCADE_DRIVE_THROTTLE_LINEAR,
			TELEOPCONTROL_ARCADE_DRIVE_STEER_LINEAR,
			TELEOPCONTROL_ARCADE_DRIVE_THROTTLE_CUBIC,
			TELEOPCONTROL_ARCADE_DRIVE_STEER_CUBIC,
			TELEOPCONTROL_SCALED_ARCADE_DRIVE_THROTTLE_LINEAR,
			TELEOPCONTROL_SCALED_ARCADE_DRIVE_STEER_LINEAR,
			TELEOPCONTROL_SCALED_ARCADE_DRIVE_THROTTLE_CUBIC,
			TELEOPCONTROL_SCALED_ARCADE_DRIVE_STEER_CUBIC,            
			TELEOPCONTROL_END,
			MAX_TESTS
        };

        ITest() = default;
        virtual ~ITest() = default;

        //-----------------------------------------------------------------------------------
        // Method:          Init
        // Description:     Setup the test
        // Returns:         void
        //-----------------------------------------------------------------------------------
        virtual void Init
        (
        	ITest::ITEST_CASE_ID   test    // <I> - test case identifier
        ) = 0;

        //-----------------------------------------------------------------------------------
        // Method:          Periodic
        // Description:     Run the test
        // Returns:         void
        //-----------------------------------------------------------------------------------
        virtual void Periodic() = 0;

        //-----------------------------------------------------------------------------------
        // Method:          Stop
        // Description:     Stop the test
        // Returns:         void
        //-----------------------------------------------------------------------------------
        virtual void Stop() = 0;
};


#endif /* SRC_TEST_ITEST_H_ */
